#!/usr/bin/perl

###############################################################################
# Setup.pl                                                                    #
###############################################################################
# UltraRank Ver. 1.00b by UltraScripts.com                                    #
# Scripts written by Jacky W.W. Yung, WebMaster@UltraScripts.com              #
# Documents written by Jeff Bradbury, Glacier@UltraScripts.com                #
# Available from http://www.UltraScripts.com/UltraRank/                       #
# --------------------------------------------------------------------------- #
# PROGRAM NAME : UltraRank                                                    #
# VERSION : 1.00 Beta                                                         #
# LAST MODIFIED : 04/15/1999                                                  #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999 Jacky Yung. All Rights Reserved.                         #
#                                                                             #
# This program is free software; you can redistribute it and/or modify it     #
# under the terms of the GNU General Public License as published by the Free  #
# Software Foundation; either version 2 of the License, or (at your option)   #
# any later version.                                                          #
#                                                                             #
# This program is distributed in the hope that it will be useful, but WITHOUT #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for   #
# more details.                                                               #
#                                                                             #
# You should have received a copy of the GNU General Public License along'    #
# with this program; if not, write to the Free Software Foundation, Inc., 59  #
# Temple Place - Suite 330, Boston, MA  02111-1307, USA.                      #
###############################################################################
&ParseForm;

if ($input{'act'} eq "") {
	&Setup;
}elsif ($input{'act'} eq "Save") {
	&Save;
}elsif ($input{'act'} eq "Check") {
	&Check;
}else{
	&Setup;
}

###############################################################################
# Setup                                                                       #
###############################################################################
sub Setup {
	if (-e "UltraRank.var") {
		require "UltraRank.var";
		$DataPath=$Con{'DataPath'};
		$MembersPath=$Con{'MembersPath'};
		$HTMLPath=$Con{'HTMLPath'};
		$MailProg=$Con{'MailProg'};
		$URLCGI=$Con{'URLCGI'};
		$URLHTML=$Con{'URLHTML'};
		$SiteTitle=$Con{'SiteTitle'};
		$EMail=$Con{'EMail'};
		$ListFileName=$Con{'ListFileName'};

		$ListFileExt{'html'}="";
		$ListFileExt{'htm'}="";
		$ListFileExt{'shtml'}="";
		$ListFileExt{$Con{'ListFileExt'}}="selected";

		$NumSites=$Con{'NumSites'};
		$NumSitesPage=$Con{'NumSitesPage'};
		$NumSitesBreak=$Con{'NumSitesBreak'};

		$RankBy{'TotalHits'}="";
		$RankBy{'HitsPerDay'}="";
		$RankBy{'HitsInDay'}="";
		$RankBy{'HitsInWeek'}="";
		$RankBy{'HitInMonth'}="";
		$RankBy{$Con{'RankBy'}}="selected";

		$MinimumHits=$Con{'MinimumHits'};
		$MaxSubjectLength=$Con{'MaxSubjectLength'};
		$MaxDesLength=$Con{'MaxDesLength'};

		$TableWidth=$Con{'TableWidth'};

		$TableAlign="";
		$TableAlign="";
		$TableAlign{$Con{'TableAlign'}}="selected";

		$TableBordColor=$Con{'TableBordColor'};
		$TableSpac=$Con{'TableSpac'};
		$TablePad=$Con{'TablePad'};
		$TableBGColor=$Con{'TableBGColor'};
		$TableBG=$Con{'TableBG'};
		$TableHeaderColor=$Con{'TableHeaderColor'};
		$HeaderTextColor=$Con{'HeaderTextColor'};
		$HeaderTextSize=$Con{'HeaderTextSize'};
		$TableColColor=$Con{'TableColColor'};
		$TextFace=$Con{'TextFace'};
		$TextColor=$Con{'TextColor'};
		$TextSize=$Con{'TextSize'};
		$TextFieldSize=$Con{'TextFieldSize'};

		$LogErrors="";
		if ($Con{'LogErrors'} eq "on") {
			$LogErrors=" checked";
		}
		$AntiCheat="";
		if ($Con{'AntiCheat'} eq "on") {
			$AntiCheat=" checked";
		}
		$AgreeTerm="";
		if ($Con{'AgreeTerm'} eq "on") {
			$AgreeTerm=" checked";
		}
		$SendConfirm="";
		if ($Con{'SendConfirm'} eq "on") {
			$SendConfirm=" checked";
		}
		$ReviewBeList="";
		if ($Con{'ReviewBeList'} eq "on") {
			$ReviewBeList=" checked";
		}
		$UseLock="";
		if ($Con{'UseLock'} eq "on") {
			$UseLock=" checked";
		}
		$UseCron="";
		if ($Con{'UseCron'} eq "on") {
			$UseCron=" checked";
		}

		$TimeToUpdate=$Con{'TimeToUpdate'};
		$BannerWidth=$Con{'BannerWidth'};
		$BannerHeight=$Con{'BannerHeight'};
		if (-e "$Con{'DataPath'}/Rank.dat") {
			require "$Con{'DataPath'}/Rank.dat";
		}
	}
	
	&PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form action="Setup.pl" method="POST">
<input type=hidden name=act value="Save">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF" colspan="2"><font face="Arial" size="2" color="White"><b>CONFIGURE VARIABLES</b></font></td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Absolute Paths</b></font>
			</td><td bgcolor="silver" width="480">
				<font face="Verdana" size="1" color="Black">
				<b>Directory Path of Data</b>
				<br><font size="1" color="Navy">The absolute directory path that where the data file will be located.<br>(ex. /home/yourdomain/cgi-bin/UltraRank/Data)</font>
				</font><br>
				<input type="Text" name="DataPath" value="$DataPath" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>Directory Path of Members</b>
				<br><font size="1" color="Navy">The absolute directory path that where the members data file will be located.<br>(ex. /home/yourdomain/cgi-bin/UltraRank/Data/members)</font>
				</font><br>
				<input type="Text" name="MembersPath" value="$MembersPath" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>Directory Path of HTML Lists</b>
				<br><font size="1" color="Navy">The absolute directory path that where the HTML list pages will be located.<br>(ex. /home/yourdomain/UltraRank)</font>
				</font><br>
				<input type="Text" name="HTMLPath" value="$HTMLPath" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>Absolute Path for SendMail Location</b>
				<br><font size="1" color="Navy">The location of the SendMail program.<br>(ex. /usr/sbin/sendmail)</font>
				</font><br>
				<input type="Text" name="MailProg" value="$MailProg" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>URLs</b></font>
			</td><td bgcolor="silver" width="480">
				<font face="Verdana" size="1" color="Black">
				<b>CGI URL</b>
				<br><font size="1" color="Navy">The URL that where the UltraRank scripts located.<br>(ex. http://yourdomain/cgi-bin/UltraRank)</font>
				</font><br>
				<input type="Text" name="URLCGI" value="$URLCGI" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>HTML Lists URL</b>
				<br><font size="1" color="Navy">The URL that where the HTML list pages will be located.<br>(ex. http://yourdomain/UltraRank)</font>
				</font><br>
				<input type="Text" name="URLHTML" value="$URLHTML" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Lists Options</b></font>
			</td><td bgcolor="silver" width="480">
				<font face="Verdana" size="1" color="Black">
				<b>Site Title</b>
				<br><font size="1" color="Navy">The title of your top site list.</font>
				</font><br>
				<input type="Text" name="SiteTitle" value="$SiteTitle" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>E-Mail Address</b>
				<br><font size="1" color="Navy">Your e-mail address.</font>
				</font><br>
				<input type="Text" name="EMail" value="$EMail" style="font-family: Verdana; width: 100%;">
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Choose a filename and extension for your list pages:</b>
						<br><font size="1" color="Navy">The first HTML list page that will be print to?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="ListFileName" value="$ListFileName" size="7">
						<select name="ListFileExt">
							<option value="html"$ListFileExt{'html'}>.html</option>
	   						<option value="htm"$ListFileExt{'htm'}>.htm</option>
	   						<option value="shtml"$ListFileExt{'shtml'}>.shtml</option>
						</select></td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>How many sites do you want to ranked:</b>
						<br><font size="1" color="Navy">The total number of sites to be listed?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="NumSites" value="$NumSites" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>How many pages to make the list:</b>
						<br><font size="1" color="Navy">The amount of HTML files to be used to make the list?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="NumSitesPage" value="$NumSitesPage" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>After how many sites insert a break:</b>
						<br><font size="1" color="Navy">After how many site insert a break in the list?<br>(leave blank if none)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="NumSitesBreak" value="$NumSitesBreak" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Minimum Hits:</b>
						<br><font size="1" color="Navy">The minimum number of hits to get listed.</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="MinimumHits" value="$MinimumHits" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Site Title Max Length:</b>
						<br><font size="1" color="Navy">The maximum number of characters allowed for member site titles.</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="MaxSubjectLength" value="$MaxSubjectLength" size="3" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Site Description Max Length:</b>
						<br><font size="1" color="Navy">The maximum number of characters allowed for member site descriptions.</font>
						</font>
					</td><td valign="top">
						<input type="Text" name="MaxDesLength" value="$MaxDesLength" size="3" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
	~;
	for ($i=1;$i<5;$i++) {
		$ToNum=$Rank{"ToNum".$i};
		$ShowSiteName=$Rank{"ShowSiteName".$i};
		$ShowSiteBanner=$Rank{"ShowSiteBanner".$i};
		$ShowSiteDes=$Rank{"ShowSiteDes".$i};
		$SiteFontSize=$Rank{"SiteFontSize".$i};
		$SiteDesFontSize=$Rank{"SiteDesFontSize".$i};
		$SiteFontColor=$Rank{"SiteFontColor".$i};
		$BGColor=$Rank{"BGColor".$i};
		$Align=$Rank{"Align".$i};
		if ($ShowSiteName eq "on") {
			$ShowSiteName=" checked";
		}
		if ($ShowSiteBanner eq "on") {
			$ShowSiteBanner=" checked";
		}
		if ($ShowSiteDes eq "on") {
			$ShowSiteDes=" checked";
		}
		print qq~
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>To </b></font><input type="Text" value="$ToNum" name="ToNum$i" size="4"><br>&nbsp;
					</td><td valign="top" width="130">
						&nbsp;
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Show Site Title:</b></font>
					</td><td valign="top">
						<input type="Checkbox" name="ShowSiteName$i"$ShowSiteName>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Show Site Banner:</b></font>
					</td><td valign="top">
						<input type="Checkbox" name="ShowSiteBanner$i"$ShowSiteBanner>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Show Site Description:</b></font>
					</td><td valign="top">
						<input type="Checkbox" name="ShowSiteDes$i"$ShowSiteDes>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Font Size of Site Title:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$SiteFontSize" name="SiteFontSize$i" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Font Size of Site Description:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$SiteDesFontSize" name="SiteDesFontSize$i" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Font Color:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$SiteFontColor" name="SiteFontColor$i" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Background Color:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$BGColor" name="BGColor$i" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Align:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$Align" name="Align$i" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
		~;
	}
	print qq~			
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Display Options<br><font size="1">(for non-list pages)</font></b></font>
			</td><td bgcolor="silver" width="480">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Table width:</b>
						<br><font size="1" color="Navy">The width value to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="TableWidth" value="$TableWidth" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table Align:</b>
						<br><font size="1" color="Navy">The align for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableAlign" value="$TableAlign" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table border color:</b>
						<br><font size="1" color="Navy">The border color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableBordColor" value="$TableBordColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table cellspacing:</b>
						<br><font size="1" color="Navy">The cellspacing value to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableSpac" value="$TableSpac" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table cellpadding:</b>
						<br><font size="1" color="Navy">The cellpadding value to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TablePad" value="$TablePad" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table bgcolor:</b>
						<br><font size="1" color="Navy">The background color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableBGColor" value="$TableBGColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table background:</b>
						<br><font size="1" color="Navy">The background graphic to use for table?</font>
						</font>
					</td><td valign="top">
						<input type="Text" name="TableBG" value="$TableBG" size="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Table header color:</b>
						<br><font size="1" color="Navy">The header color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="TableHeaderColor" value="$TableHeaderColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Header text color:</b>
						<br><font size="1" color="Navy">The header text color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="HeaderTextColor" value="$HeaderTextColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Header text size:</b>
						<br><font size="1" color="Navy">The header text size to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="HeaderTextSize" value="$HeaderTextSize" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table first column color:</b>
						<br><font size="1" color="Navy">The first column color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableColColor" value="$TableColColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text face:</b>
						<br><font size="1" color="Navy">The text name which you use?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TextFace" value="$TextFace" size="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text color:</b>
						<br><font size="1" color="Navy">The normal text color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TextColor" value="$TextColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text size:</b>
						<br><font size="1" color="Navy">The normal text size to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TextSize" value="$TextSize" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text field size:</b>
						<br><font size="1" color="Navy">The text field size to use for table?</font>
						</font>
					</td><td valign="top">
						<input type="Text" name="TextFieldSize" value="$TextFieldSize" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Miscellaneous Options</b></font>
			</td><td bgcolor="silver" width="480">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Log Errors?</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="LogErrors"$LogErrors></td></tr>
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Use anti-cheat gateway?</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="AntiCheat"$AntiCheat></td></tr>
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Review new additions before listing?</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="ReviewBeList"$ReviewBeList></td></tr>
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Use FLock</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="UseLock"$UseLock></td></tr>
				</table>
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Are you using crontabs to update the list:</b>
						<br><font size="1" color="Navy">Using crontabs to update the list?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Checkbox" name="UseCron"$UseCron>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Reset time:</b>
						<br><font size="1" color="Navy">The number of seconds between reset?<br>(if you didn't use crontabs to update)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TimeToReset" value="$TimeToReset" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Rerank time:</b>
						<br><font size="1" color="Navy">The number of seconds between re-lists?<br>(if you didn't use crontabs to update)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TimeToUpdate" value="$TimeToUpdate" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Banner width:</b>
						<br><font size="1" color="Navy">The width value to use for all banners?<br>(if you want all the banners with same size)</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="BannerWidth" value="$BannerWidth" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Banner height:</b>
						<br><font size="1" color="Navy">The height value to use for all banners?<br>(if you want all the banners with same size)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="BannerHeight" value="$BannerHeight" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
			</td></tr>
			<tr><td bgcolor="silver" colspan="2">
				<center><input type="Submit" value="SAVE CONFIGURATION" style="font-family: Arial; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# Save                                                                        #
###############################################################################
sub Save {
	$input{'EMail'}=~s/\@/\\\@/g;
	open(VARS,">./UltraRank.var") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the variables file.");
		print VARS<<TEXT;
\$Con{'DataPath'}="$input{'DataPath'}";
\$Con{'MembersPath'}="$input{'MembersPath'}";
\$Con{'HTMLPath'}="$input{'HTMLPath'}";
\$Con{'MailProg'}="$input{'MailProg'}";
\$Con{'URLCGI'}="$input{'URLCGI'}";
\$Con{'URLHTML'}="$input{'URLHTML'}";
\$Con{'SiteTitle'}="$input{'SiteTitle'}";
\$Con{'EMail'}="$input{'EMail'}";
\$Con{'ListFileName'}="$input{'ListFileName'}";
\$Con{'ListFileExt'}="$input{'ListFileExt'}";
\$Con{'NumSites'}="$input{'NumSites'}";
\$Con{'NumSitesPage'}="$input{'NumSitesPage'}";
\$Con{'NumSitesBreak'}="$input{'NumSitesBreak'}";
\$Con{'RankBy'}="$input{'RankBy'}";
\$Con{'MinimumHits'}="$input{'MinimumHits'}";
\$Con{'MaxSubjectLength'}="$input{'MaxSubjectLength'}";
\$Con{'MaxDesLength'}="$input{'MaxDesLength'}";
\$Con{'TableWidth'}="$input{'TableWidth'}";
\$Con{'TableAlign'}="$input{'TableAlign'}";
\$Con{'TableBordColor'}="$input{'TableBordColor'}";
\$Con{'TableSpac'}="$input{'TableSpac'}";
\$Con{'TablePad'}="$input{'TablePad'}";
\$Con{'TableBGColor'}="$input{'TableBGColor'}";
\$Con{'TableBG'}="$input{'TableBG'}";
\$Con{'TableHeaderColor'}="$input{'TableHeaderColor'}";
\$Con{'HeaderTextColor'}="$input{'HeaderTextColor'}";
\$Con{'HeaderTextSize'}="$input{'HeaderTextSize'}";
\$Con{'TableColColor'}="$input{'TableColColor'}";
\$Con{'TextFace'}="$input{'TextFace'}";
\$Con{'TextColor'}="$input{'TextColor'}";
\$Con{'TextSize'}="$input{'TextSize'}";
\$Con{'TextFieldSize'}="$input{'TextFieldSize'}";
\$Con{'LogErrors'}="$input{'LogErrors'}";
\$Con{'AntiCheat'}="$input{'AntiCheat'}";
\$Con{'ReviewBeList'}="$input{'ReviewBeList'}";
\$Con{'UseLock'}="$input{'UseLock'}";
\$Con{'UseCron'}="$input{'UseCron'}";
\$Con{'TimeToUpdate'}="$input{'TimeToUpdate'}";
\$Con{'BannerWidth'}="$input{'BannerWidth'}";
\$Con{'BannerHeight'}="$input{'BannerHeight'}";
1;
TEXT
	close(VARS);
	open(RANK,">$input{'DataPath'}/Rank.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the Rank.dat file.");
	for ($i=1;$i<5;$i++) {
$ToNum=$input{"ToNum".$i};
$ShowSiteName=$input{"ShowSiteName".$i};
$ShowSiteBanner=$input{"ShowSiteBanner".$i};
$ShowSiteDes=$input{"ShowSiteDes".$i};
$SiteFontSize=$input{"SiteFontSize".$i};
$SiteDesFontSize=$input{"SiteDesFontSize".$i};
$SiteFontColor=$input{"SiteFontColor".$i};
$BGColor=$input{"BGColor".$i};
$Align=$input{"Align".$i};
			print RANK<<TEXT;
\$Rank{'ToNum$i'}="$ToNum";
\$Rank{'ShowSiteName$i'}="$ShowSiteName";
\$Rank{'ShowSiteBanner$i'}="$ShowSiteBanner";
\$Rank{'ShowSiteDes$i'}="$ShowSiteDes";
\$Rank{'SiteFontSize$i'}="$SiteFontSize";
\$Rank{'SiteDesFontSize$i'}="$SiteDesFontSize";
\$Rank{'SiteFontColor$i'}="$SiteFontColor";
\$Rank{'BGColor$i'}="$BGColor";
\$Rank{'Align$i'}="$Align";
TEXT
	}
		print RANK "1;";
	close(RANK);
	unless(-e "$input{'DataPath'}/Reset.dat") {
		if(!$FUNCTIONS::FORM{'USING_CRON'}) {
			open(TIME, ">$input{'DataPath'}/Reset.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the Reset.dat file.");
				$Time=time;
				print TIME "\$TIME{'ReListTime'}  = $Time;\n";
				print TIME "\$TIME{'ResetTime'} = $Time;\n";
				print TIME "1;";
			close(TIME);
			chmod(0666, "$input{'DataPath'}/Reset.dat");
		}
	}
	&Check;
}

###############################################################################
# Check                                                                       #
###############################################################################
sub Check{
	require "UltraRank.var";
	$Error=0;
	print "Content-type: text/html\n\n";
	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($Con{'DataPath'});
	&GetPermission;
	$DataPath{'Mode'}=$CurMode;
	if ($DataPath{'Mode'} eq "777") {
		$DataPath{'Stat'}="OK";
	}else{
		$Error=1;
		$DataPath{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}

	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($Con{'MembersPath'});
	&GetPermission;
	$MembersPath{'Mode'}=$CurMode;
	if ($MembersPath{'Mode'} eq "777") {
		$MembersPath{'Stat'}="OK";
	}else{
		$Error=1;
		$MembersPath{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}

	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($Con{'HTMLPath'});
	&GetPermission;
	$HTMLPath{'Mode'}=$CurMode;
	if ($HTMLPath{'Mode'} eq "777") {
		$HTMLPath{'Stat'}="OK";
	}else{
		$Error=1;
		$HTMLPath{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}
	
	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat("./URAdmin.pl");
	&GetPermission;
	$URAdmin{'Mode'}=$CurMode;
	if ($URAdmin{'Mode'} eq "755") {
		$URAdmin{'Stat'}="OK";
	}else{
		$Error=1;
		$URAdmin{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}
	
	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat("./UltraRank.pl");
	&GetPermission;
	$UltraRank{'Mode'}=$CurMode;
	if ($UltraRank{'Mode'} eq "755") {
		$UltraRank{'Stat'}="OK";
	}else{
		$Error=1;
		$UltraRank{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}

	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat("./URAccount.pl");
	&GetPermission;
	$URAccount{'Mode'}=$CurMode;
	if ($URAccount{'Mode'} eq "755") {
		$URAccount{'Stat'}="OK";
	}else{
		$Error=1;
		$URAccount{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}

	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat("./UltraRank.lib");
	&GetPermission;
	$UltraRanklib{'Mode'}=$CurMode;
	if ($UltraRanklib{'Mode'} eq "755") {
		$UltraRanklib{'Stat'}="OK";
	}else{
		$Error=1;
		$UltraRanklib{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}

	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat("./UltraRank.var");
	&GetPermission;
	$UltraRankvar{'Mode'}=$CurMode;
	if ($UltraRankvar{'Mode'} eq "666") {
		$UltraRankvar{'Stat'}="OK";
	}else{
		$Error=1;
		$UltraRankvar{'Stat'}="<font color=\"red\">INCORRECT</font>";
	}
	
	print<<HTML;
<html>
<head>
	<title>Setup UltraRank</title>
</head>
<body>
<center><table width="580" border="0" cellspacing="0" cellpadding="0" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="2" cellpadding="4">
			<tr><td bgcolor="#0080FF"><font face="Verdana" size="2" color="White"><b>INFORMATION</b></font></td></tr>
			<tr><td bgcolor="silver">
				<table width="100%" border="0" cellspacing="1" cellpadding="1">
					<tr bgcolor="CCCCCC">
						<td><font face="Verdana" size="1"><b>FILE/DIRECTORY</b></font></td>
						<td><font face="Verdana" size="1"><b>CURRRENT</b></font></td>
						<td><font face="Verdana" size="1"><b>RECOMMENDED</b></font></td>
						<td><font face="Verdana" size="1"><b>STATUS</b></font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">$Con{'DataPath'}</font></td>
						<td><font face="Arial" size="1">$DataPath{'Mode'}</font></td>
						<td><font face="Arial" size="1">777</font></td>
						<td><font face="Arial" size="1">$DataPath{'Stat'}
						</font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">$Con{'MembersPath'}</font></td>
						<td><font face="Arial" size="1">$MembersPath{'Mode'}</font></td>
						<td><font face="Arial" size="1">777</font></td>
						<td><font face="Arial" size="1">$MembersPath{'Stat'}
						</font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">$Con{'HTMLPath'}</font></td>
						<td><font face="Arial" size="1">$HTMLPath{'Mode'}</font></td>
						<td><font face="Arial" size="1">777</font></td>
						<td><font face="Arial" size="1">$HTMLPath{'Stat'}
						</font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">URAdmin.pl</font></td>
						<td><font face="Arial" size="1">$URAdmin{'Mode'}</font></td>
						<td><font face="Arial" size="1">755</font></td>
						<td><font face="Arial" size="1">$URAdmin{'Stat'}
						</font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">UltraRank.pl</font></td>
						<td><font face="Arial" size="1">$UltraRank{'Mode'}</font></td>
						<td><font face="Arial" size="1">755</font></td>
						<td><font face="Arial" size="1">$UltraRank{'Stat'}
						</font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">URAccount.pl</font></td>
						<td><font face="Arial" size="1">$URAccount{'Mode'}</font></td>
						<td><font face="Arial" size="1">755</font></td>
						<td><font face="Arial" size="1">$URAccount{'Stat'}
						</font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">UltraRank.lib</font></td>
						<td><font face="Arial" size="1">$UltraRanklib{'Mode'}</font></td>
						<td><font face="Arial" size="1">755</font></td>
						<td><font face="Arial" size="1">$UltraRanklib{'Stat'}
						</font></td>
					</tr>
					<tr>
						<td><font face="Arial" size="1">UltraRank.var</font></td>
						<td><font face="Arial" size="1">$UltraRankvar{'Mode'}</font></td>
						<td><font face="Arial" size="1">666</font></td>
						<td><font face="Arial" size="1">$UltraRankvar{'Stat'}
						</font></td>
					</tr>
				</table>
				<hr align="CENTER" size=2>
HTML
	if ($Error==1) {
		print qq~<font face="Arial" size="2"><b>ERROR</b><br>Some <font color="Red">problems</font> were discovered in the permissions you have set on the UltraRank.<br>Use the table above to determine which files may have incorrect permissions change them. After you have changed them, run this script again to verify that everything is now setup properly.</font>~;
	}else{
		print qq~<font face="Arial" size="2"><b>CONGRATULATIONS</b><br>You have all files set up properly and are ready to run <a href="URAdmin.pl">UltraRank Administrator Center</a>.</font>~;
	}
	print<<HTML;
			</td></tr>
		</table>
	</td></tr>
</table></center>
</body>
</html>
HTML
	exit;
}

###############################################################################
# ParseForm                                                                   #
###############################################################################
sub ParseForm{
	local($buffer, @pair, $pair, $name, $value);
	if($ENV{'REQUEST_METHOD'} eq "POST"){
    	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}elsif($ENV{'REQUEST_METHOD'} eq "GET"){
		$buffer=$ENV{'QUERY_STRING'};
	}
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/<!--(.|\n)*-->//g;
		$value =~ s/\n/<br>/g;
		$input{$name} = $value;
	}
}

###############################################################################
# PrintHTMLHeader                                                             #
###############################################################################
sub PrintHTMLHeader {
	if ($HeaderDefine ne "TRUE") {
		print "Content-type: text/html\n\n";
		$HeaderDefine = "TRUE";
	}
}

###############################################################################
# PrintHTMLTop                                                                #
###############################################################################
sub PrintHTMLTop {
	print qq~
<html>
<head>
	<title>UltraRank Setup</title>
</head>
<body>
	~;
}

###############################################################################
# PrintHTMLBottom                                                             #
###############################################################################
sub PrintHTMLBottom {
	print qq~
</body>
</html>
	~;
}

###############################################################################
# GetPermission                                                               #
###############################################################################
sub GetPermission {
	if($mode eq "16895" || $mode eq "33279") {
		$CurMode = "777";
	}elsif($mode eq "33261" || $mode eq "16877") {
		$CurMode = "755";
	}elsif($mode eq "33204" || $mode eq "16820") {
		$CurMode = "664";
	}elsif($mode eq "33188" || $mode eq "16804") {
		$CurMode = "644";
	}elsif($mode eq "33060" || $mode eq "16676") {
		$CurMode = "444";
	}elsif($mode eq "33206" || $mode eq "16822") {
		$CurMode = "666";
	}elsif($mode eq "33277" || $mode eq "16893") {
		$CurMode = "775";
	}elsif($mode eq "33270" || $mode eq "16886") {
		$CurMode = "766";
	}elsif($mode eq "33252" || $mode eq "16868") {
		$CurMode = "744";
	}elsif($mode eq "33276" || $mode eq "16892") {
		$CurMode = "774";
	}else {
		$CurMode = "Unknown";
	}
}